﻿FuBar = {}
FuBar.version = "2.0"
FuBar.db = {}
FuBar.db.profile = {}

local broker = LibStub("LibDataBroker-1.1")
local brokerPlugins = {}

local hooked, origSetIcon, origSetText

function FuBar:OpenMenu(frame, button)
	local Dewdrop = AceLibrary:HasInstance("Dewdrop-2.0") and AceLibrary("Dewdrop-2.0")
	
	if not Dewdrop:IsRegistered(frame) then
		if type(frame.OnMenuRequest) == "table" and (not frame.OnMenuRequest.handler or frame.OnMenuRequest.handler == frame) and frame.OnMenuRequest.type == "group" then
			Dewdrop:InjectAceOptionsTable(frame, frame.OnMenuRequest)
			if frame.OnMenuRequest.args and CheckFuBar() and not frame.independentProfile then
				frame.OnMenuRequest.args.profile = nil
			end
		end
		Dewdrop:Register(frame,
			'children', type(frame.OnMenuRequest) == "table" and frame.OnMenuRequest or function(level, value, valueN_1, valueN_2, valueN_3, valueN_4)
				if level == 1 then
					Dewdrop:AddLine(
						'text', frame:GetTitle(),
						'isTitle', true
					)

					if frame.OnMenuRequest then
						frame:OnMenuRequest(level, value, false, valueN_1, valueN_2, valueN_3, valueN_4)
					end
				end
			end,
			'point', function(frame)
				local x, y = frame:GetCenter()
				local leftRight
				if x < GetScreenWidth() / 2 then
					leftRight = "LEFT"
				else
					leftRight = "RIGHT"
				end
				if y < GetScreenHeight() / 2 then
					return "BOTTOM" .. leftRight, "TOP" .. leftRight
				else
					return "TOP" .. leftRight, "BOTTOM" .. leftRight
				end
			end,
			'dontHook', true
		)
	end
	Dewdrop:Open(frame)
end

local GetTitle = function() return self.title or self.name end

function FuBar:ShowPlugin(plugin)
	local name = plugin:ToString()
	if not brokerPlugins[name] then
		local brokerPlugin = broker:NewDataObject(name)
		brokerPlugin.text = name
		brokerPlugin.icon = plugin.icon or plugin.hasIcon
		
		plugin.brokerPlugin = brokerPlugin
		
		-- dirty hack, we only need to hook FuBarPlugin once, hopefully this won't cause problems
		if not hooked then
			origSetIcon = plugin.SetIcon
			origSetText = plugin.SetText
			hooked = true
		end
		plugin.SetIcon = function(self, path) origSetIcon(self, path) self.brokerPlugin.icon = path end
		plugin.SetText = function(self, text) origSetText(self, text) self.brokerPlugin.text = text end
		
		brokerPlugin.OnMenuRequest = plugin.brokerPlugin
		brokerPlugin.OnClick = function(frame, button) if button == "RightButton" then frame.GetTitle = GetTitle frame.OnMenuRequest = plugin.OnMenuRequest FuBar:OpenMenu(frame, button) end end
		
		brokerPlugins[name] = brokerPlugin
	end
end

function FuBar:RegisterPlugin(plugin)
end

function FuBar:IsChangingProfile()
end

local fakePanel = {}
function fakePanel:AddPlugin()

end
function FuBar:GetPanel()
	return fakePanel
end